// glcontrol.cpp: implementation of the CGLControl class.
//
//////////////////////////////////////////////////////////////////////

#include "glstdafx.h"
#include "glcontrol.h"

CGLControl *CGLControl::m_SelectedControl=NULL;
#define z -1.0

static inline GLfloat ConvertPosition(GLfloat x)
{
	return x*2-1.0;
}
CGLControl::CGLControl(GLfloat p_fx,GLfloat p_fy,
	GLfloat p_fWidth,GLfloat p_fHeight)
{
	m_fx=p_fx;//ConvertPosition(p_fx);
	m_fy=p_fy;//-ConvertPosition(p_fy);
	m_fWidth=p_fWidth;
	m_fHeight=p_fHeight;
	if (!CGL::AddControl(this)) throw 1;
}
void CGLControl::Draw(void)
{
	glBegin(GL_QUADS);		
		glVertex3f(m_fx+m_fWidth,m_fy-m_fHeight,z);
		glVertex3f(m_fx+m_fWidth,m_fy,z);
		glVertex3f(m_fx,m_fy,z);
		glVertex3f(m_fx,m_fy-m_fHeight,z);
	glEnd();
	

}

