// glslider.h: interface for the CGLSlider class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GLSLIDER_H__C6A727D5_37D0_43F7_9535_3FDD015018E8__INCLUDED_)
#define AFX_GLSLIDER_H__C6A727D5_37D0_43F7_9535_3FDD015018E8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "importexport.h"
#include "gllabel.h"

typedef void PFNONSLIDERPROC(GLfloat);
class CGL_API  CGLSlider : public CGLLabel  
{
protected:
	GLfloat m_fValue;//0.0...1.0
	PFNONSLIDERPROC *m_pfnOnSlider;
public:
	CGLSlider(GLfloat p_fx,GLfloat p_fy,
	GLfloat p_fWidth,GLfloat p_fHeight,
	const string& p_strText,	PFNONSLIDERPROC * p_pfnOnSlider=NULL);


	void SetValue(GLfloat p_fValue);
	GLfloat GetValue(void) {return m_fValue;}

	virtual void Draw(void);
	virtual void OnMouse(GLint p_nButton,GLint p_nState,GLfloat p_fx,GLfloat p_fy);
	virtual void OnSpecialKey(GLint p_nKey,GLint p_nx,GLint p_ny);
	virtual ~CGLSlider();

};

#endif // !defined(AFX_GLSLIDER_H__C6A727D5_37D0_43F7_9535_3FDD015018E8__INCLUDED_)
