#include "glstdafx.h"
#include "gl.h"
#include "glframe.h"
#include "glbutton.h"
#include "gltextbox.h"
#include "glslider.h"
#include "gleditbox.h"
#include "gllistbox.h"
#include <iostream.h>
//CGL * gl;
void OnRender(void);
void OnSpecialKey(GLint,GLint,GLint);
void OnTimer(GLint value);
void OnEndEdit(const string& p_strEnterText);
void OnChoose(const string& p_strChoose);
	GLfloat alpha=90.0f;
CGLVector3 v(1.0f,0.0f,0.0f);
CGLFrame fr(10);

void OnButton(void)
{
	cout<<"Button pressed "<<cpputils::GetTimeString();
}
int main(int argc, char *argv[])
{
	CGL::InitOpenGL("CGL",&argc,argv);
	cout.setf(ios::unitbuf);
	CGL::SetRenderProc(OnRender);
	CGL::SetSpecialKeyProc(OnSpecialKey);
	CGL::SetTimerProc(OnTimer);

	CGLControl* p=new CGLButton(-0.5,0.0,1.0,0.2," ",OnButton);


	p=new CGLButton(-0.5,-0.4,1.0,0.2,"",OnButton);



	string s="   .      3457     .\n     .";



	p=new CGLSlider(-1.0,-0.5,0.4,0.2,s);


	p=new CGLTextBox(-1.0,0.9,0.4,0.5,s);




	p=new CGLEditBox(0.0,1.0,1.0,0.2,"  :",20,OnEndEdit);



	CGLListBox *plb=new CGLListBox(0.5,-0.5,0.5,0.4,"My list box",OnChoose);
	plb->AddItem("first");
	plb->AddItem("second");
	plb->AddItem("The 3");


	CGL::MainLoop();
	return 0;
}

void OnRender(void)
{
	//gl->DrawString(0.1,0.1,"ABCDEFGHIJKLMNOPQRSTUVWXYZ");
//	gl->DrawString(0.1,-0.1,"abcdefghijklmnopqrstuvwxyz");
	//gl->DrawText(-0.9,0.8,0.5,0.5,"CGL -      ");
	//gl->DrawString(-0.9,0.9,"CGL sample is demonstrating how to use CGL.");
	//gl->DrawString(0.2,0.2,"ABABB");
	
	glTranslatef(0.0f,0.0f,-10.0f);
	CGL::SetPointLight(GL_LIGHT0,CGLVector3(0.0f,2.0f,0.0f),CGLColor(1.0f,1.0f,1.0f));
	glRotatef(-90,0.0f,1.0f,0.0f);
	glRotatef(alpha,0.0f,1.0f,0.0f);
	//glRotatef(360.0f-alpha,0.0f,1.0f,0.0f);
	fr.Draw();
	glLoadIdentity();
	glTranslatef(0.0,0.0,-5.0);
	glutSolidSphere(1.0,10,10);

 	
}

void OnSpecialKey(GLint p_nKey, GLint p_nx,GLint p_ny)
{
	static float bs=0.0;
	bs+=0.1;
	switch (p_nKey)
	{
	case GLUT_KEY_F1:
		glClearColor(bs,1.0f,1.0f,1.0f);
		break;
	case 'a':
	case 'A':
		glClearColor(0.0,0.0,0.0,0.0);
		break;
	}
}	
	
void OnTimer(GLint value)
{
	alpha-=10.1f;
	if (alpha<=0.0f) alpha=360.0f;
}

void OnEndEdit(const string& p_strEnterText)
{
	cout<<"End of typing: "<<p_strEnterText.data()<<"\n";
}


void OnChoose(const string& p_strChoose)
{
	cout<<"Your choose: "<<p_strChoose.data()<<endl;
}