////////////////////////////////////////////////////////////////////////////////
//: spacesheep.cpp
//:  Ը 
//: http://www.DXGames.narod.ru
//e-mail: UrvanovF@hotmail.ru
////////////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stdio.h>
#include	<string.h>
#include	<gl/gl.h>
#include	<gl/glut.h>
#include	<gl/glaux.h>
#include	"glext.h"

#include	"Vector3D.h"
#include	"Vector2D.h"
#include "3dobject.h"
#include "myutils.h"

C3DObject *g_p3doSpacesheep1=NULL;
extern "C"
{
	#include	"tga.h"
}



float	 SpacesheepAngle    = 0;
float	 SpacesheepAngle2   = 0;
int		 reflMode = GL_REFLECTION_MAP_ARB;
//int		 reflMode = GL_NORMAL_MAP_ARB;
int		 object   = 0;
//unsigned texture;



void DrawSpacesheep (unsigned texture)
{

	GLenum err;
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glPixelStorei   ( GL_UNPACK_ALIGNMENT, 1 );							// set 1-byte alignment

	glTexParameterf ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE );
	glTexParameterf ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE );

	glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );
	glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

	glEnable ( GL_TEXTURE_CUBE_MAP_ARB );

    glTexGeni ( GL_S, GL_TEXTURE_GEN_MODE, reflMode );
    glTexGeni ( GL_T, GL_TEXTURE_GEN_MODE, reflMode );
	glTexGeni ( GL_R, GL_TEXTURE_GEN_MODE, reflMode );

	glEnable  ( GL_TEXTURE_CUBE_MAP_ARB );

	glBindTexture ( GL_TEXTURE_CUBE_MAP_ARB, texture );
	if ((err=glGetError())!=GL_NO_ERROR) 
		printf("Error binding texture cube map: %i",err);

	glTexParameterf ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE );
	glTexParameterf ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE );

	//glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_S, GL_CLAMP );
	//glTexParameteri ( GL_TEXTURE_CUBE_MAP_ARB, GL_TEXTURE_WRAP_T, GL_CLAMP );

    glEnable  ( GL_TEXTURE_GEN_S );
    glEnable  ( GL_TEXTURE_GEN_T );
    glEnable  ( GL_TEXTURE_GEN_R );



	glDisable(GL_LIGHTING);
	g_p3doSpacesheep1->Draw();
	//glutSolidSphere(5,100,100);
	glEnable(GL_LIGHTING);
	glPopAttrib();
}



void InitSpacesheep()
{
	printf("Initializeing cube map...");
	if ( !isExtensionSupported ( "GL_ARB_texture_cube_map" ) )
	{
		printf ( "ARB_texture_cube_map NOT supported.\n" );

		throw 1;
	}

	WriteOk();
	printf("Loading spacesheep...");
	g_p3doSpacesheep1=new C3DObject("spacesheep1");
	WriteOk();
}
