#include "stdafx.h"
#include "connection.h"
#include "data.h"
extern C3DCursor cursor;

const int MAX_ENTER=20;
void OnEnter(const string& p_strEnterString);
void OnChoose(const string& p_strChoice);
void OnSet(void);
void OnRemove(void);
void ReturnToEditor(void);
void OnCancel(void);

extern void InitializeUserInterface(void);
extern void OnKeyboard(char,int,int);


CGLEditBox *g_pEditBox;
CGLListBox *plb;
void OnConnectionPoint(void)
{

	CGL::RemoveAllControls();
	string s="    :";
	g_pEditBox=new CGLEditBox(-0.5,-0.6,1.0,0.2,s,MAX_ENTER,OnEnter);
	plb=new CGLListBox(-0.5,0.8,1.0,0.8,"    :",OnChoose);

	if (cursor.GetConnectionPointsCount())
	{
		char str1[10];
		
		for (int n=0;n<cursor.GetConnectionPointsCount();n++)
		{
			plb->AddItem(ltoa(cursor.GetConnectionPoint(n).m_nNumber,str1,10));
		}
	}
	CGLControl *p=new CGLButton(-0.5,0.0,0.4,0.1,"",OnSet);
	p=new CGLButton(0.1,0.0,0.4,0.1,"",OnRemove);
	p=new CGLButton(-1.0,1.0,0.4,0.1,"",OnCancel);
	CGL::SetKeyboardProc(NULL);

}

void OnEnter(const string& p_strEnterString)
{
	
	
	CGL::RemoveAllControls();
	cursor.AddConnectionPoint(atol(p_strEnterString.data()));

	CGL::SetKeyboardProc(OnKeyboard);
	InitializeUserInterface();
}


void OnChoose(const string& p_strChoice)
{
	
}


void OnSet(void)
{
	CConnectionPoint pt;
	string& str1=plb->GetSelectedItem();
	if (str1!="")
	{
		pt.m_nNumber =atol(str1.c_str());
		pt.m_fx=cursor.m_fx;
		pt.m_fy=cursor.m_fy;
		pt.m_fz=cursor.m_fz;
		cursor.SetConnectionPoint(plb->GetSelectedItemIndex(),pt);
		ReturnToEditor();
	}
}

void OnRemove(void)
{
	int n=plb->GetSelectedItemIndex();
	if (n!=-1) 
	{
		cursor.RemoveConnectionPoint(n);
		ReturnToEditor();
	}
}


void OnCancel(void)
{
	ReturnToEditor();
}

void ReturnToEditor(void)
{
		CGL::SetKeyboardProc(OnKeyboard);
		CGL::RemoveAllControls();
		InitializeUserInterface();
}
