#include "gl.h"
#include "3dobject.h"

#include "files.h"

extern C3DObject* g_p3do;
extern CSimple3DObject *g_ps3do;
extern int g_nSelectedConnection;

extern void InitializeUserInterface(void);

void OnSave(const string& p_strFileName);
void OnLoad(const string& p_strFileName);

void SaveToFile(void)
{
	CGL::RemoveAllControls();
	new CGLEditBox(-0.5,0.1,1.0,0.2,".   :",80,OnSave);
}

void OnSave(const string& p_strFileName)
{
	g_p3do->SaveToFile(p_strFileName);
	CGL::RemoveAllControls();
	InitializeUserInterface();
}

void LoadFromFile(void)
{
	CGL::RemoveAllControls();
	new CGLEditBox(-0.5,0.1,1.0,0.2,".   :",80,OnLoad);
}

void OnLoad(const string& p_strFileName)
{
	delete g_p3do;
	g_p3do=new C3DObject(p_strFileName);
	g_ps3do=g_p3do->GetBaseSimple3DObject();
	g_nSelectedConnection=0;
	CGL::RemoveAllControls();
	InitializeUserInterface();
}