// gllabel.cpp: implementation of the CGLLabel class.
//
//////////////////////////////////////////////////////////////////////

#include "glstdafx.h"
#include "gllabel.h"

#include "gl.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGLLabel::CGLLabel(GLfloat p_fx,GLfloat p_fy,
	GLfloat p_fWidth,GLfloat p_fHeight,
	const string& p_strText)
	:CGLControl(p_fx,p_fy,p_fWidth,p_fHeight)
{

	m_strText=p_strText;
	//if (!m_strText) throw 1;
}


void CGLLabel::Draw()
{
	CGL::DrawText(m_fx,m_fy-CGL::GetLetterSize(),m_fWidth,0.0,m_strText.data(),m_strText.length());
}
CGLLabel::~CGLLabel()
{
	//free(m_strText);

}
