// 3DObject.h: interface for the C3DObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_3DOBJECT_H__C7497F27_31CE_41D1_A98B_98E5616BE8EC__INCLUDED_)
#define AFX_3DOBJECT_H__C7497F27_31CE_41D1_A98B_98E5616BE8EC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "simple3dobject.h"


class C3DObject  
{
	CSimple3DObject * m_s3doBase;
	static int m_nGlobalGraphQuality;
public:
	C3DObject();
	C3DObject(CSimple3DObject p_s3doBase);
	C3DObject(const string& p_strFileName);
	//void RemoveConnection(int p_nIndex);
	//void SetConnection(int p_nIndex, const string & p_strFolder);
	//const CConnection& GetConnection(int p_nIndex);
	//int GetConnectionsCount(void);
	CSimple3DObject * GetBaseSimple3DObject(void);
	void SetBaseSimple3DObject(const string&  p_strFolderName, float p_fGraphQuality);

	void Draw();
	void SaveToFile(const string& p_strFileName);
	
	virtual ~C3DObject();

	static void SetGlobalGraphQuality(int p_nGlobalGraphQuality);
	static int GetGlobalGraphQuality(void);

};

#endif // !defined(AFX_3DOBJECT_H__C7497F27_31CE_41D1_A98B_98E5616BE8EC__INCLUDED_)
